stages:
  - check
  - build
  - deploy

lint:
  stage: check
  image: python:3.7-buster
  # see https://docs.gitlab.com/ee/ci/caching/#cache-python-dependencies
  variables:
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"
  cache:
    paths:
      - .cache/pip
      - venv/
  before_script:
    # want to set up a virtualenv to cache
    - apt-get install -y --no-install-recommends git
    - python -V
    - python -m venv venv
    - source venv/bin/activate
    - python -m pip install -U pip setuptools wheel
    - python -m pip install pre-commit
    - python -m pip freeze
  script:
    - pre-commit run --all-files

.frontend:
  variables:
    CONTEXT: frontend

.backend:
  variables:
    CONTEXT: backend

.build:
  stage: build
  image:
    name: gitlab-registry.cern.ch/ci-tools/docker-image-builder
    entrypoint: [""]
  script:
    - /kaniko/executor --context $CI_PROJECT_DIR/$CONTEXT/
      --destination $CI_REGISTRY_IMAGE/$CONTEXT:$CI_COMMIT_REF_SLUG
      --no-push
      --tarPath image.tar
  artifacts:
    paths:
      - image.tar
    expire_in: 1 day

.deploy:
  stage: deploy
  image:
    name: gcr.io/go-containerregistry/crane:debug
    entrypoint: [""]
  script:
    - crane auth login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - crane push image.tar $CI_REGISTRY_IMAGE/$CONTEXT:$CI_COMMIT_REF_SLUG
    - crane push image.tar $CI_REGISTRY_IMAGE/$CONTEXT:latest
  rules:
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
    - if: $CI_COMMIT_TAG

frontend:build:
  extends:
    - .frontend
    - .build

backend:build:
  extends:
    - .backend
    - .build

frontend:deploy:
  extends:
    - .frontend
    - .deploy
  needs:
    - frontend:build

backend:deploy:
  extends:
    - .backend
    - .deploy
  needs:
    - backend:build
